package cpcns.dingZhi.rili.controller;

package .var.folders.cl.9twcgjfx4vsg5zl73c6wxmvm0000gn.T;

import cpcns.base.common.User;
import cpcns.base.common.util.JsonWithJacksonUtils;
import cpcns.base.generic.ResultMessage;
import cpcns.dangAnBase.base.controller.DangAnBaseController;
import cpcns.dingZhi.rili.model.riLi;
import cpcns.dingZhi.rili.service.IRiLiService;
import cpcns.utils.DateUtil;
import java.text.SimpleDateFormat;
import java.util.Calendar;
import java.util.GregorianCalendar;
import java.util.List;
import java.util.Map;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import org.apache.log4j.Logger;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.ui.Model;
import org.springframework.web.bind.annotation.RequestMapping;

@Controller
@RequestMapping({"/riLi"})
public class RiLiController extends DangAnBaseController {
  private static final Logger logger = Logger.getLogger(cpcns.dingZhi.rili.controller.RiLiController.class);
  
  @Autowired
  private IRiLiService riLiService;
  
  @RequestMapping({"/query.do"})
  public String query(HttpServletRequest request, Model model) {
    logger.info("打开日历！！");
    return "rili/rili";
  }
  
  @RequestMapping({"/toSet.do"})
  public String toSet(HttpServletRequest request, Model model) {
    logger.info("打开设置页面！！");
    return "rili/setRiLiEdit";
  }
  
  @RequestMapping({"/setRiLi.do"})
  public void setRiLi(HttpServletRequest request, Model model, HttpServletResponse response) {
    logger.info("设置开始！！");
  }
  
  @RequestMapping({"/getdate.do"})
  public void getdate(HttpServletRequest request, HttpServletResponse response, Model model) {
    logger.info("查询水印数据开始！！");
    String mon = request.getParameter("mon");
    long month = Long.parseLong(mon);
    String timeText = DateUtil.stamp2NYRDate(month);
    timeText = timeText.substring(0, timeText.lastIndexOf("-"));
    List<Map<String, Object>> list = this.riLiService.getAll(timeText);
    logger.info("查询水印数据结束！！");
    String str = JsonWithJacksonUtils.getInstance().obj2Json(list).replaceAll(" 00:00:00", "")
      .replaceAll(":00", "").replaceAll("", "").replaceAll("SHEZHIDATE", "sheZhiDate").replaceAll("BEIYONGZIFU", "beiYongZiFu")
      .replaceAll("RIQI", "riQi").replaceAll("BEIYONGZI", "beiYongZi").replaceAll("MINGCHENG", "mingCheng")
      .replaceAll("ZHUANGTAI", "zhuangTai").replaceAll("SHEZHIRENMINGCHENG", "sheZhiRenMingCheng").replaceAll("KAISHI", "kaiShi")
      .replaceAll("LEIXING", "leiXing").replaceAll("HANGBIAOSHI", "hangBiaoShi").replaceAll("JIESHU", "jieShu")
      .replaceAll("SHEZHIRENBIAOSHI", "sheZhiRenBiaoShi").replaceAll("CIXU", "ciXu").replaceAll("BEIZHU", "beiZhu");
    responseWriter(response, str);
  }
  
  @RequestMapping({"/save.do"})
  public void save(HttpServletRequest request, Model model, HttpServletResponse response) {
    ResultMessage rm = new ResultMessage();
    String info = "";
    logger.info("保存数据开始！！");
    try {
      String startYear = request.getParameter("startYear");
      String endYear = request.getParameter("endYear");
      String mingCheng = request.getParameter("mingCheng");
      int leiXing = Integer.parseInt(request.getParameter("leiXing"));
      int type = Integer.parseInt(request.getParameter("type"));
      if (type > 1) {
        startYear = DateUtil.stamp2NYRDate(Long.parseLong(startYear));
        endYear = DateUtil.stamp2NYRDate(Long.parseLong(endYear));
      } 
      User user = getCurrentUser();
      this.riLiService.setRiLi(startYear, endYear, mingCheng, leiXing, user);
      rm.setSuccess(true);
      info = "操作成功！";
    } catch (Exception e) {
      System.out.println(e.getMessage());
      e.printStackTrace();
      rm.setSuccess(false);
      info = "操作失败！";
    } 
    logger.info("保存水印数据结束！！");
    rm.setInfo(info);
    responseWriter(response, rm.toString());
  }
  
  @RequestMapping({"/setSXBSJ.do"})
  public void setSXBSJ(HttpServletRequest request, Model model, HttpServletResponse response) {
    ResultMessage rm = new ResultMessage();
    String info = "";
    logger.info("保存数据开始！！");
    try {
      String sb = request.getParameter("sb");
      String xb = request.getParameter("xb");
      String hbs = request.getParameter("hbs");
      User user = getCurrentUser();
      this.riLiService.setSXBSJ(sb, xb, hbs, user);
      rm.setSuccess(true);
      info = "操作成功！";
    } catch (Exception e) {
      System.out.println(e.getMessage());
      e.printStackTrace();
      rm.setSuccess(false);
      info = "操作失败！";
    } 
    logger.info("保存水印数据结束！！");
    rm.setInfo(info);
    responseWriter(response, rm.toString());
  }
  
  @RequestMapping({"/getSXBSJ.do"})
  public void getSXBSJ(HttpServletRequest request, Model model, HttpServletResponse response) {
    ResultMessage rm = new ResultMessage();
    String info = "";
    logger.info("保存数据开始！！");
    StringBuffer str = new StringBuffer();
    try {
      riLi rl = (riLi)this.riLiService.getById(riLi.class, Integer.valueOf(1));
      if (rl != null) {
        str.append(",\"sbshijian\":\"").append(rl.getKaiShi()).append("\",\"xbshijian\":\"").append(rl.getJieShu()).append("\",\"hangBiaoShi\":").append(1);
      } else {
        str.append(",\"sbshijian\":\"8:30\",\"xbshijian\":\"16:30\",hangBiaoShi\":").append(0);
      } 
      rm.setSuccess(true);
      info = "操作成功！";
    } catch (Exception e) {
      System.out.println(e.getMessage());
      e.printStackTrace();
      rm.setSuccess(false);
      info = "操作失败！";
    } 
    logger.info("保存水印数据结束！！");
    rm.setInfo(info);
    String info_ = rm.toString().replaceAll("}", str + "}");
    responseWriter(response, info_);
  }
  
  public static StringBuffer getYears(int year1, int year2) {
    StringBuffer dateList = new StringBuffer();
    int count = year2 - year1;
    for (int i = 0; i < count; i++) {
      for (int j = 0; j < 12; j++) {
        StringBuffer str = getMonthWekDay(year1 + i, j);
        dateList.append(str.toString());
      } 
    } 
    return dateList;
  }
  
  public static StringBuffer getMonthWekDay(int year, int mouth) {
    StringBuffer dateList = new StringBuffer();
    SimpleDateFormat simdf = new SimpleDateFormat("yyyy-MM-dd");
    Calendar calendar = new GregorianCalendar(year, mouth, 1);
    Calendar endCalendar = new GregorianCalendar(year, mouth, 1);
    endCalendar.add(2, 1);
    do {
      int weekday = calendar.get(7);
      if (weekday == 1 || weekday == 7)
        if (dateList.length() == 0) {
          dateList.append(simdf.format(calendar.getTime()));
        } else {
          dateList.append(",").append(simdf.format(calendar.getTime()));
        }  
      calendar.add(5, 1);
    } while (calendar.getTimeInMillis() < endCalendar.getTimeInMillis());
    return dateList;
  }
}
